// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*! 
 * @file Benchmark_big.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Benchmark_big.h"

#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

BenchMarkBig::BenchMarkBig()
{

    m_index = 0;
}

BenchMarkBig::~BenchMarkBig()
{
}

BenchMarkBig::BenchMarkBig(const BenchMarkBig &x)
{
    m_data = x.m_data;
    m_index = x.m_index;
}

BenchMarkBig::BenchMarkBig(BenchMarkBig &&x)
{
    m_data = std::move(x.m_data);
    m_index = x.m_index;
}

BenchMarkBig& BenchMarkBig::operator=(const BenchMarkBig &x)
{
    m_data = x.m_data;
    m_index = x.m_index;
    
    return *this;
}

BenchMarkBig& BenchMarkBig::operator=(BenchMarkBig &&x)
{
    m_data = std::move(x.m_data);
    m_index = x.m_index;
    
    return *this;
}

size_t BenchMarkBig::getMaxCdrSerializedSize(size_t current_alignment)
{
    size_t initial_alignment = current_alignment;
            
    current_alignment += ((8388608) * 1) + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    return current_alignment - initial_alignment;
}

size_t BenchMarkBig::getCdrSerializedSize(const BenchMarkBig&, size_t current_alignment)
{
    size_t initial_alignment = current_alignment;
            
    current_alignment += ((8388608) * 1) + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    return current_alignment - initial_alignment;
}

void BenchMarkBig::serialize(eprosima::fastcdr::Cdr &scdr) const
{
    scdr << m_data;
    scdr << m_index;
}

void BenchMarkBig::deserialize(eprosima::fastcdr::Cdr &dcdr)
{
    dcdr >> m_data;
    dcdr >> m_index;
}

size_t BenchMarkBig::getKeyMaxCdrSerializedSize(size_t current_alignment)
{
	size_t current_align = current_alignment;
            



    return current_align;
}

bool BenchMarkBig::isKeyDefined()
{
    return false;
}

void BenchMarkBig::serializeKey(eprosima::fastcdr::Cdr &) const
{
	 
	 
}